ASSEMBLE
* constants for ppp implementation



_flag	EQU #7e
_escape	EQU #7d


* Protocols (beware : little indian is here !)

_IP	EQU #2100
_IPc	EQU #21			compressed
_LCP	EQU #21c0
_IPCP	EQU #2180
_Comp_VJ	EQU #2d		must be implemented one day !
_Uncomp_VJ	EQU #2f

* PPP states

_R4_PPP	EQU 5			within R4

_Dead	EQU 0
_Establish	EQU 1
_Authenticate	EQU 2
_Network	EQU 3
_Terminate	EQU 4

* LCP/IPCP states

_R4_LCP	EQU 6			within R4
_R4_IPCP	EQU 7
_R4_TIMEOUT	EQU 8

_Initial	EQU 0
_Starting	EQU 1
_Closed	EQU 2
_Stopped	EQU 3
_Closing	EQU 4
_Stopping	EQU 5
_Req_Sent	EQU 6
_Ack_Rcvd	EQU 7
_Ack_Sent	EQU 8
_Opened	EQU 9

* LCP/IPCP codes

_Conf_Request	EQU 1
_Conf_Ack	EQU 2
_Conf_Nack	EQU 3
_Conf_Reject	EQU 4
_Term_Request	EQU 5
_Term_Ack	EQU 6
_Code_Reject	EQU 7
_Protocol_Reject	EQU 8
_Echo_Request	EQU 9
_Echo_Reply	EQU 10
_Discard_Request	EQU 11

* LCP/IPCP packet
*
* Code(8) | Identifier(8) | Length(16)
* Data...
*

* LCP options

_Maximum_Receive_Unit	EQU 1
_Async_Contr_Char_Map	EQU 2	* 0x00A00000
_Auth_Proto	EQU 3
_Quality_Proto	EQU 4
_Magic_Number	EQU 5
_RESERVED	EQU 6
_Prot_Field_Compr	EQU 7
_Adr_Contr_Field_Compr	EQU 8

* IPCP options

_IP_Addresses	EQU 1		deprecated
_IP_Comp_Proto	EQU 2
_IP_Address	EQU 3

* data flow control

_XON	EQU 17
_XOFF	EQU 19

_maxmru	EQU 128		 to hold into buffer, even if escaped !


RPL
