ASSEMBLE
* receiving a packet @d0, r0 nibbles
* defragmentation is done here,
* but beware of little indians !

* TODO: check checksum, IP dest, IP source

recIP
	AD0EX	A
	D1=A	A		* d1 pointe dans l'en-tte

	C=0	A
				* taille en-tte en mots de 32 bits
	C=DAT1	P
	CSL	B		* *8 -> en quartets
	CSRB.F	B
	D=C	A

	A=A+C	A
	D0=A	A		points on datas


	D1=D1+	1		* version
	A=DAT1	P
	LC(1)	_IPv
	?A=C	P
	GOYES	+
	RTN			* de l'ipv6 ou quoi ?

+
	C=0	XS
	D1=D1+	3		taille en octets
	C=DAT1	B		hi
	CSL	A
	CSL	A
	D1=D1+	2
	C=DAT1	B		low
	C=C+C	A		in nibbles

	A=R0.F	A		buffer's size
	?C<=A	A		enough data ?!
	GOYES	+
	ST=0	_b_st_trame
	RTN			silently ignore

+
	D=C-D	A		-> taille donnes en quartets

	A=0	A
	D1=D1+	2		* identification
	A=DAT1	4
	R0=A.F	A		* et y reste oubli pour l'instant !

	A=0	XS
	D1=D1+	4		* fragmentation
	A=DAT1	B		* le haut

	D1=D1+	2
	ASL	A
	ASL	A
	A=DAT1	B		* le bas

	ABIT=0	_b_congestion	*
	ABIT=0	_b_dont_fragment	* ne nous intressent pas

	?ABIT=1	_b_more_fragments
	GOYES	+

	GOTO	nofragip

+

	ABIT=0	_b_more_fragments

	?A#0	A
	GOYES	milieufragip	* dpl non nul, +more_fragments : au milieu !

* le premier fragment : le recopier en entier

* c contient toujours la taille totale en quartets
	D=C	A		* taille totale

	D1=D1-	2		* fragmentation
	DAT1=A	4		* l'efface : ce paquet devient normal

	D1=D1-	12		* dbut paquet

	GOTO	recopiefragip

milieufragip

* un fragment du milieu : recopier les donnes

* d contient la taille des donnes
* c contient la taille totale en octets

	AD0EX	A
	D1=A	A
	AD0EX	A

	ASL	A		* dplacement*16 -> quartets
	C=C-D	A		* taille en-tte
	A=A+C	A		* la rajoute au dplacement

* fragment @d1 de taille d quartets, dplacement dans a quartets
recopiefragip
	B=A	A

	A=R4.F	A
	LC(5)	(fragid)-(sauvegardes)
	A=A+C	A		identification
	D0=A	A
	A=0	A
	A=DAT0	4
	C=R0.F	A
	?A#C	A
	GOYES	+		a new fragmented ip packet !

	D0=D0+	4		size
	C=DAT0	A		gets the remaining size
	C=C-D	A		subs what we're putting
	DAT0=C	A
	R0=C.F	A		and saves the result

	GOTO	++

+
	DAT0=C	4		the new id
	D0=D0+	4		size
	C=0	A
	C=C-D	A
	DAT0=C	A		resets the size

++
	A=R4.F	A
	LC(5)	offsetbufip
	A=A+C	A
	D0=A

	B=B+A	A		* ajoute le dplacement
	A=B	A
	D0=A	A		* dbut o recopier

-
	A=DAT1	P
	DAT0=A	P
	D1=D1+	1
	D0=D0+	1
	D=D-1	A
	?D#0	A
	GOYES	-

	C=R0.F	A
	?C=0	A
	GOYES	+		* taille restante nulle ? on a fini le paquet !
	ST=0	_b_st_trame	* bouffe le fragment
	RTN

+
	A=R4.F	A
	LC(5)	(fragtotsize)-(sauvegardes)
	A=A+C	A

	D0=A	A
	A=DAT0	A
	R0=A.F	A

	ASRB.F	A			* en octets

	B=A	A

	A=R4.F	A
	LC(5)	offsetbufip
	A=A+C	A		beginning of the ip buffer
	D0=A	A

	A=B	A

	D0=D0+	6		* taille totale : bas
	DAT0=A	B
	D0=D0-	2		* haut
	ASR	A
	ASR	A
	DAT0=A	B

	D0=D0-	4		* dbut paquet

* todo recalculer le checksum d'en-tte

	GOTO	recIP		* on le rceptionne comme d'hab !




nofragip
	?A=0	A
	GOYES	normalip	* dplacement nul ? c'est un paquet normal.
* dplacement non nul, sans fragment qui suit, on va pouvoir avoir la taille du
* paquet original  le dplacement + taille totale du paquet
* c contient toujours la taille totale du paquet

	B=A	A		* il faut garder le dplacement !

	ASL	A		* *16 -> en quartets
	A=A+C	A		* taille totale du paquet original
	R1=A.F	A
	R2=C.F	A		* taille totale paquet (y compris les headers)

	A=R4.F	A
	LC(5)	(fragid)-(sauvegardes)
	A=A+C	A

	D1=A	A

	A=0	A
	A=DAT1	4
	D1=D1+	4
	C=R0.F	A		identification
	?C=A	A		the current fragmented ip packet ?
	GOYES	+

	D1=D1-	4
	DAT1=C	4
	D1=D1+	4
	C=0	A
	DAT1=C	A		resets the current size !
+

	C=R1.F	A		* taille totale paquet original

	A=DAT1	A
	A=A+C	A		* ajoute toute la taille  recevoir
	DAT1=A	A

	D1=D1+	5		* taille totale
	DAT1=C	A

	A=B	A		* dplacement
	C=R2.F	A		* taille totale paquet
	GOTO	milieufragip	* pour le reste, c'est comme un fragment du milieu !


normalip
	D1=D1+	4		* protocole (ttl ne nous intresse pas)
	A=DAT1	B
	B=A	B

	D1=D1+	6		* adresse ip source
	A=DAT1	8


* taille des donnes reues dans d, adresse ip en a, d0 pointe dessus
	LC(2)	_proto_ICMP
	?C#B	B
	GOYES	+
	GOTO	ip_icmp

+
	LC(2)	_proto_TCP
	?C#B	B
	GOYES	+
	GOTO	ip_tcp

+
	LC(2)	_proto_UDP
	?C#B	B
	GOYES	+
	GOTO	ip_udp
+

* TODO:  envoyer un paquet ICMP protocol unreachable !

	RTN

RPL
