INCLUDE include/fcs.h
ASSEMBLE
*
*
* FCS is a special CRC for ppp : see RFC 1331
* address in D0, size in C in nibbles
* uses R0 !
*
*
xor				* (a^c)->d * a nor modified
	B=A	A
	D=C	A
	B=-B-1	A
	D=-D-1	A
	CAEX	A
	D=D&C	A
	CAEX	A
	C=C&B	A
	D=C!D	A
	RTN


compfcs
	LA(4)	PPPINITFCS		* start value

* quoting RFC1331 :
* fcs = (fcs >> 8) ^ fcstab[(fcs ^ *cp++) & 0xff]

-
	C=C-CON	A,2		one byte less
	GOC	endfcs
	R0=C.F	A
	C=DAT0	A

	GOSUB	xor

	LC(5)	#000FF
	D=D&C	A

	D=D+D	A
	D=D+D	A		offset in table

	LC(5)	(+)-(tablefcs)
	B=C	A
	C=PC	A
+
	C=C-B	A

	C=C+D	A

	D1=C	A
	C=DAT1	A
	P=	3
	ASR	WP
	ASR	WP
	P=	0
	GOSUB	xor
	C=D	A
	A=C	A		new FCS

	D0=D0+	2		8bits farther
	C=R0.F	A
	GOTO	-

endfcs
	A=-A-1	A		final not
	RTN
RPL
