ASSEMBLE
* sends a tcp packet given the seq nb in R0, the ack nb in R1, the code bits in
* R2
tcpsendpacket
* reminds socket parms
	A=R4.F	A
	LC(5)	(SocketEnCours)-(sauvegardes)
	C=C+A	A
	D0=C	A

	C=DAT0	8				ports
	B=C	W
	D0=D0+	8
	C=DAT0	8
	R3=C	W				ip address

* sends a tcp packet given the seq nb in R0, the ack nb in R1, the code bits in
* R2, the ports in B, the ip in R3
tcpsendportippacket
	A=R4.F	A
	LC(5)	offsetbuf			take some room
	C=C+A	A
	D0=C	A

* pseudo-header

	LC(5)	(ipanous)-(sauvegardes)
	C=C+A	A
	D1=C	A
	C=DAT1	8				our ip
	DAT0=C	8
	D0=D0+	8

	C=R3	W
	DAT0=C	8				his ip
	D0=D0+	8

	LC(4)	(_proto_TCP)*256		protocol
	DAT0=C	4
	D0=D0+	4

	LC(4)	5*4*256				tcp length in bytes
	DAT0=C	4
	D0=D0+	4

* tcp header
	C=B	W				ports
	DAT0=C	8
	D0=D0+	16

	C=R0					seq
	P=	#C
-
	D0=D0-	2
	DAT0=C	2
	CSR	W
	CSR	W
	P=P+1
	GONC	-
	D0=D0+	16

	C=R1
	P=	#C
-
	D0=D0-	2
	DAT0=C	2				ack
	CSR	W
	CSR	W
	P=P+1
	GONC	-
	D0=D0+	8

	LC(2)	#50				lg_ent 5*32bits
	DAT0=C	2
	D0=D0+	2
	
	C=R2	B				code bits
	DAT0=C	2
	D0=D0+	2

	C=0	A
	?ST=1	_b_st_socket
	GOYES	+
	LC(1)	#6				window 1536

+
	DAT0=C	4
	D0=D0+	4

	C=0	W
	DAT0=C	8				checksum + urgent pointer

	LC(5)	offsetbuf
	C=C+A	A
	D0=C	A

	LC(5)	8*2				size in 16words
	B=C	A

	GOSUB	calctotcontr
	D1=D1-	6				on the checksum
	DAT1=A	2				(lo)
	ASR	A
	ASR	A
	D1=D1-	2
	DAT1=A	2				(hi)

	D0=D0+	16
	D0=D0+	8

	LC(2)	_proto_TCP
	B=C	B				protocol

	LC(5)	5*8				size

	A=R3	W				ip

	GOTOL	sendip


tcpconnect
* prepares the config packet, waits the automate to be in good state before
* giving back hand, without carry
* if timed out, with carry
* remind the binding
	A=R4.F	A
	LC(5)	(tcpseq)-(sauvegardes)
	C=C+A	A
	D0=C
	
	D1=(5)	=CRC				random value for sequence nb
	C=DAT1	4
	CSL	A
	CSL	W
	CSL	W
	CSL	W
	C=DAT0	4			to have sth different !
	C=DAT1	4
	R0=C
	P=	7
	C=C+1	WP
	P=	0
	DAT0=C	8
	
	C=0	W				no ack
	R1=C
	LC(2)	#02				SYN
	R2=C	B

	GOSUB	tcpsendpacket


	GOSUBL	ztick
	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D0=C	A
	LC(1)	_tcp_Syn_Sent			waiting for ack/syn
	DAT0=C	P
-
	GOSUBL	tick
	GOC	+
	GOSUBL	recppp

	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D0=C	A
	A=DAT0	P
	LC(1)	_tcp_Opened
	?A#C	P
	GOYES	-
	RTNCC
+
	RTNSC

tcpaccept
* waiting for last client to disconnect
-
	GOSUBL	recppp
	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D0=C	A
	A=DAT0	P
	LC(1)	_tcp_Initial
	?A#C	P
	GOYES	-

* now listening
	LC(1)	_tcp_Listen
	DAT0=C	P
	D0=D0+	(tcpseq)-(tcpstatus)
	D1=(5)	=CRC
	C=DAT1	4
	CSL	A
	CSL	W
	CSL	W
	CSL	W
	C=DAT0	4				to have sth different !
	C=DAT1	4
	DAT0=C	8				new seq

* waiting for client for connect
-
	GOSUBL	recppp
	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D0=C	A
	A=DAT0	P
	LC(1)	_tcp_Opened
	?A#C	P
	GOYES	-
* Connected !
	RTN

tcpdisconnect
* sends end of connection packet, and gives back hand

	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D0=C	A

	A=DAT0	P
	LC(1)	_tcp_Fin_Rcvd
	?A=C	P
	GOYES	+
	
	LC(1)	_tcp_Fin_Sent
	GOTO	++
+
	LC(1)	_tcp_Last_Ack
++
	DAT0=C	P

	D0=D0+	(tcpseq)-(tcpstatus)

	C=DAT0	8
	R0=C
	P=	7
	C=C+1	WP
	P=	0
	DAT0=C	8

	D0=D0+	8				ack
	C=DAT0	8
	R1=C
	LC(2)	#11				FIN + ACK
	R2=C	B

	GOTO	tcpsendpacket

* announces our window
tcpopenwindow
	A=R4.F	A
	LC(5)	(tcpseq)-(sauvegardes)
	C=C+A	A
	D0=C	A

	C=DAT0	8
	R0=C
	D0=D0+	(tcpack)-(tcpseq)
	C=DAT0	8
	R1=C

	LC(2)	#10			ACK
	R2=C.F	B
	GOTO	tcpsendpacket
RPL
