ASSEMBLE
* packet received @D0, D nibbles, ip address in A
ip_tcp
* TOTO: checksum
	ST=0	_b_st_trame

	R0=A

	C=D	A
	R1=C.F	A

* checks dest port
	A=R4.F	A
	LC(5)	(SocketEnCours)-(sauvegardes)
	C=C+A	A
	D1=C	A
	D0=D0+	4
	C=DAT0	4
	D0=D0-	4
	A=DAT1	4
	P=	3
	ST=0	_b_st_TCP_RST
	?C=A	WP
	GOYES	+

* bad dest port !, send RST
	ST=1	_b_st_TCP_RST
	
+
	P=	0

	D1=D1+	(socketconnection)-(SocketEnCours)
	C=DAT1	P
	?CBIT=1	0			a TCP socket ?
	GOYES	+
	ST=1	_b_st_TCP_RST
+
	
	C=DAT0	8			ports (Big endian)
	D=C	W			save in D
	D0=D0+	8

	P=	#C
-
	CSL	W
	CSL	W
	C=DAT0	2			his seq nb
	D0=D0+	2
	P=P+1
	GONC	-
	R2=C

	P=	#C
-
	CSL	W
	CSL	W
	C=DAT0	2			his ack
	D0=D0+	2
	P=P+1
	GONC	-
	R3=C

	D0=D0+	1
	C=0	A
	C=DAT0	1			lg_ent (in 32words)
	B=C	A			save in B
	D0=D0+	1

	C=DAT0	2			code bits

	?ST=0	_b_st_TCP_RST
	GOYES	tcpnosendrst

* just send a RST !
	A=R0
	AR3EX				exchg ip & seq
	R0=A
	
	A=R2
	?CBIT=1	_b_tcp_SYN
	GOYES	+
	?CBIT=1	_b_tcp_FIN
	GOYES	+
	GOTO	++
+
	P=	7
	A=A+1	WP
++
	R1=A				ack

	C=D	W
	CSL	A
	CSL	W
	CSL	W			exchg ports
	CSL	W
	DSR	W
	DSR	W
	DSR	W
	DSR	A
	P=	3
	C=D	WP
	P=	0
	B=C	W

	LC(2)	#14			RST
	R2=C.F	B

	GOTO	tcpsendportippacket

tcpnosendrst
	?CBIT=0	_b_tcp_RST
	GOYES	+
	LA(5)	XErr_TCPRST		RST !
	GOTOL	erreur
+

	D1=D1+	(tcpack)-(socketconnection)
	?CBIT=0	_b_tcp_SYN
	GOYES	+

* SYN -> sets the ack to be sent
	A=R2
	DAT1=A	8
+

* checks the seq nb
	CR2EX				and saves the code bits
	A=DAT1	8			our ack nb
	P=	7
	?C=A	WP
	GOYES	+
	P=	0
	RTN

+
	P=	0


	D0=D0+	2
* TODO: window checking
	D0=D0+	4

	AD0EX
	A=A-	4*8	A		beginning of the packet

	C=B	A			lg_ent

	CSL	A
	CSRB.F	A			*8 -> nibbles

	A=A+C	A			on data
	D0=A	A

	A=R1.F	A
	A=A-C	A			data size in nibbles
	R1=A.F	A

	?A=0	A			something sent ?
	GOYES	+

	C=DAT1	8			our ack
	B=0	W
	B=A	A
	BSRB.F	A
	P=	7
	C=C+B	WP			gets increased
	P=	0
	DAT1=C	8

	C=D	A
	B=C	A			gets the ports back
	DSR	W
	DSR	W
	DSR	W
	DSR	A

	C=R1.F	A			size

	A=R0				IP
	GOSUBL	udp_sock

+

* now that data were processed, let's see the code bits

	C=R2.F	B

	?CBIT=0	_b_tcp_SYN
	GOYES	+
	GOTO	tcpSYNrecvd
+
	?CBIT=0	_b_tcp_FIN
	GOYES	+
	GOTO	tcpFINrecvd
+


	?CBIT=1	_b_tcp_ACK
	GOYES	+
	GOTO	tcpackdata			not acked anything

+
	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D1=C	A

	A=DAT1	P
	LC(1)	_tcp_Syn_Rcvd			last ack for connection
	?C#A	P
	GOYES	+
	LC(1)	_tcp_Opened
	DAT1=C	P
	GOTO	++
+
	LC(1)	_tcp_Fin_Sent			our fin (first) was acked
	?C#A	P
	GOYES	+
	LC(1)	_tcp_Fin_Ackd
	DAT1=C	P
	GOTO	++
+
	LC(1)	_tcp_Last_Ack			our fin (second) was acked
	?C#A	P
	GOYES	+
	LC(1)	_tcp_Initial
	DAT1=C	P
+
tcpackdata
	A=R1.F	A
	?A#0	A
	GOYES	++
	RTN					no data to ack
++
	A=R4.F	A
	LC(5)	(tcpseq)-(sauvegardes)
	C=C+A	A
	D0=C	A

	C=DAT0	8				seq
	R0=C
	D0=D0+	8

	C=DAT0	8				ack
	R1=C
	
	LC(2)	#10				just ACK
	R2=C.F	B
	GOTO	tcpsendpacket

* SYN received ! his seq nb was already recorded

tcpSYNrecvd
	B=C	B

	A=R4.F	A
	LC(5)	(tcpconnected)-(sauvegardes)
	C=C+A	A
	D0=C	A
	LC(1)	#1				he connected
	DAT0=C	P

	C=B	B

	?CBIT=0	_b_tcp_ACK
	GOYES	tcpSYNnoACK

* SYN+ACK
	A=R4.F	A
	LC(5)	(tcpseq)-(sauvegardes)
	C=C+A	A
	D0=C	A

	C=DAT0	8
	A=R3					his ack
	P=	7
	?C=A	WP
	GOYES	+

	P=	0
	RTN					not the right seq !

+
	P=	0
	R0=C

	D0=D0-	(tcpseq)-(tcpstatus)

	LC(1)	_tcp_Opened
	DAT0=C	P

	GOTO	tcpsendack+1

tcpSYNnoACK
	A=R4.F	A
	LC(5)	(tcpstatus)-(sauvegardes)
	C=C+A	A
	D0=C	A

	LC(1)	_tcp_Syn_Rcvd
	DAT0=C	P

	D0=D0+	(tcpseq)-(tcpstatus)
	C=DAT0	8
	P=	7				seq to sync
	C=C-1	WP
	R0=C

	D0=D0+	8
	C=DAT0	8
	C=C+1	WP				ack increased
	P=	0
	DAT0=C	8
	R1=C

	LC(2)	#12				SYN + ACK
	R2=C.F	B

	GOTOL	tcpsendpacket



tcpFINrecvd
	A=R4.F	A
	LC(5)	(tcpconnected)-(sauvegardes)
	C=C+A	A
	D0=C	A

	C=0	P				he disconnected
	DAT0=C	P
	D0=D0+	(tcpstatus)-(tcpconnected)

	A=DAT0	P

	LC(1)	_tcp_Fin_Sent
	?C=A	P
	GOYES	++
	LC(1)	_tcp_Fin_Ackd
	?C=A	P
	GOYES	++

	LC(1)	_tcp_Opened
	?C=A	P
	GOYES	+
	RTN

+
	LC(1)	_tcp_Fin_Rcvd
	DAT0=C	P
	GOTO	+

++
	LC(1)	_tcp_Initial
	DAT0=C	P

+

tcpsendack+1
	D0=D0+	(tcpseq)-(tcpstatus)
	C=DAT0	8
	D0=D0+	8			seq
	R0=C

	C=DAT0	8
	P=	7
	C=C+1	WP			ack increased
	P=	0
	DAT0=C	8
	R1=C

	LC(2)	#10			just ACK
	R2=C.F	B

	GOTOL	tcpsendpacket
RPL
